package org.jboss.chap2.ex0;

import java.net.URLClassLoader;
import java.net.URL;

import org.apache.log4j.Logger;

/**
 * Wasny class loader uytkownika, ktry pokrywa standardowy model delegacyjny
 * 
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class Ex0URLClassLoader extends URLClassLoader {

	private static Logger log = Logger.getLogger(Ex0URLClassLoader.class);

	private Ex0URLClassLoader delegate;

	public Ex0URLClassLoader(URL[] urls) {
		super(urls);
	}

	void setDelegate(Ex0URLClassLoader delegate) {
		this.delegate = delegate;
	}

	protected synchronized Class loadClass(String name, boolean resolve)
			throws ClassNotFoundException {
		Class clazz = null;
		if (delegate != null) {
			log.debug(Integer.toHexString(hashCode())
					+ "; Wywoanie metody loadClass delegata: " + name);
			clazz = delegate.loadClass(name, resolve);
			log.debug(Integer.toHexString(hashCode())
					+ "; Powrt z metody loadClass delegata: " + clazz);
		} else {
			log.debug(Integer.toHexString(hashCode())
					+ "; Wywoanie metody loadClass z nadklasy: " + name);
			clazz = super.loadClass(name, resolve);
			log.debug(Integer.toHexString(hashCode())
					+ "; Powrt z metody loadClass nadklasy: " + clazz);
		}
		return clazz;
	}

	protected Class findClass(String name) throws ClassNotFoundException {
		Class clazz = null;
		log.debug(Integer.toHexString(hashCode())
				+ "; Wywoanie metody findClass z nadklasy: " + name);
		clazz = super.findClass(name);
		log.debug(Integer.toHexString(hashCode())
				+ "; Powrt z metody findClass nadklasy: " + clazz);
		return clazz;
	}
}