package org.jboss.chap2.ex4;

import javax.management.MBeanInfo;
import javax.management.MBeanOperationInfo;
import javax.management.MBeanParameterInfo;
import javax.management.ObjectName;
import javax.naming.InitialContext;

import org.jboss.jmx.adaptor.rmi.RMIAdaptor;

/**
 * Klient demonstrujcy sposb poczenia si z serwerem JMX przy uyciu
 * adaptera JMX
 * 
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.2 $
 */
public class JMXBrowser {
	/**
	 * @param args
	 *            argumenty wiersza polece
	 */
	public static void main(String[] args) throws Exception {
		InitialContext ic = new InitialContext();
		RMIAdaptor server = (RMIAdaptor) ic.lookup("jmx/invoker/RMIAdaptor");

		// Pobranie MBeanInfo komponentu JNDIView
		ObjectName name = new ObjectName("jboss:service=JNDIView");
		MBeanInfo info = server.getMBeanInfo(name);
		System.out.println("Klasa JNDIView: " + info.getClassName());

		MBeanOperationInfo[] opInfo = info.getOperations();
		System.out.println("Operacje JNDIView: ");
		for (int o = 0; o < opInfo.length; o++) {
			MBeanOperationInfo op = opInfo[o];

			String returnType = op.getReturnType();
			String opName = op.getName();
			System.out.print(" + " + returnType + " " + opName + "(");

			MBeanParameterInfo[] params = op.getSignature();
			for (int p = 0; p < params.length; p++) {
				MBeanParameterInfo paramInfo = params[p];

				String pname = paramInfo.getName();
				String type = paramInfo.getType();

				if (pname.equals(type)) {
					System.out.print(type);
				} else {
					System.out.print(type + " " + name);
				}

				if (p < params.length - 1) {
					System.out.print(',');
				}
			}
			System.out.println(")");
		}

		// Wywoanie operacji list(boolean)
		String[] sig = { "boolean" };
		Object[] opArgs = { Boolean.TRUE };
		Object result = server.invoke(name, "list", opArgs, sig);

		System.out.println("Wynik JNDIView.list(true):\n" + result);
	}
}