package org.jboss.chap2.xmbean;

import javax.naming.InitialContext;
import org.jboss.security.SecurityAssociation;
import org.jboss.security.SimplePrincipal;

/**
 * Klient odwoujcy si do XMBean za pomoc interfejsu RMI
 * 
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.2 $
 */
public class TestXMBean3 {

	/**
	 * @param args
	 *            argumenty wiersza polece
	 */
	public static void main(String[] args) throws Exception {
		InitialContext ic = new InitialContext();
		ClientInterface xmbean = (ClientInterface) ic
				.lookup("secure-xmbean/ClientInterface");

		// To wywoanie nie powinno si powie z powodu nie ustawionego
		// kontekstu bezpieczestwa
		try {
			String[] tmp = xmbean.getInitialValues();
			throw new IllegalStateException("Udao si wywoa getInitialValues");
		} catch (Exception e) {
			System.out
					.println("Spodziewany bd wywoania getInitialValues: "
							+ e.getMessage());
		}

		// Ustalenie kontekstu bezpieczestwa za pomoc SecurityAssociation
		SecurityAssociation.setPrincipal(new SimplePrincipal("admin"));

		// Pobranie atrybutu InitialValues
		String[] initialValues = xmbean.getInitialValues();
		for (int n = 0; n < initialValues.length; n += 2) {
			String key = initialValues[n];
			String value = initialValues[n + 1];
			System.out.println("key=" + key + ", value=" + value);
		}

		// Wywoanie operacji put(Object, Object)
		xmbean.put("key1", "value1");
		System.out.println("JNDIMap.put(key1, value1) successful");
		Object result0 = xmbean.get("key0");
		System.out.println("JNDIMap.get(key0): " + result0);
		Object result1 = xmbean.get("key1");
		System.out.println("JNDIMap.get(key1): " + result1);

		// Zmiana InitialValues
		initialValues[0] += ".1";
		initialValues[1] += ".2";
		xmbean.setInitialValues(initialValues);

		initialValues = xmbean.getInitialValues();
		for (int n = 0; n < initialValues.length; n += 2) {
			String key = initialValues[n];
			String value = initialValues[n + 1];
			System.out.println("klucz=" + key + ", warto=" + value);
		}
	}
}