package org.jboss.chap2.xmbean;

import javax.management.Attribute;
import javax.management.ObjectName;
import javax.naming.InitialContext;

import org.jboss.jmx.adaptor.rmi.RMIAdaptor;

/**
 * Klient demonstrujcy mechanizm utrwalania atrybutw xmbean. Przy kadym
 * uruchomieniu szuka wartoci atrybutu InitialValues, wywietla znalezione
 * wartoci i dodaje do listy kolejn par klucz/warto
 * 
 * 
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.2 $
 */
public class TestXMBeanRestart {
	/**
	 * @param args
	 *            argumenty wiersza wywoania
	 */
	public static void main(String[] args) throws Exception {
		InitialContext ic = new InitialContext();
		RMIAdaptor server = (RMIAdaptor) ic.lookup("jmx/invoker/RMIAdaptor");

		// Pobranie atrybutu InitialValues 
		ObjectName name = new ObjectName("chap2.xmbean:service=JNDIMap");
		String[] initialValues = (String[]) server.getAttribute(name,
				"InitialValues");
		System.out.println("InitialValues.length=" + initialValues.length);
		int length = initialValues.length;
		for (int n = 0; n < length; n += 2) {
			String key = initialValues[n];
			String value = initialValues[n + 1];
			System.out.println("klucz=" + key + ", warto=" + value);
		}
		// Dodanie nowej pary klucz/warto
		String[] newInitialValues = new String[length + 2];
		System.arraycopy(initialValues, 0, newInitialValues, 0, length);
		newInitialValues[length] = "klucz" + (length / 2 + 1);
		newInitialValues[length + 1] = "warto" + (length / 2 + 1);

		Attribute ivalues = new Attribute("InitialValues", newInitialValues);
		server.setAttribute(name, ivalues);
	}
}