package org.jboss.chap7.ex1.ra;

import java.io.File;
import java.io.PrintWriter;
import java.io.Serializable;
import java.util.Set;
import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;
import javax.security.auth.Subject;

import org.apache.log4j.Category;

/**
 *
 * @author  Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class FSManagedConnectionFactory 
    implements ManagedConnectionFactory, 
               Serializable
{
    static Category log = Category.getInstance(FSManagedConnectionFactory.class);
    private String rootDirPath;
    private transient File rootDir;
    
    /** Tworzy nowy obiekt FSManagedConnectionFactory */
    public FSManagedConnectionFactory()
    {
    }
    
    public Object createConnectionFactory()
        throws ResourceException
    {
        log.debug("metoda createConnectionFactory");
        throw new UnsupportedOperationException("Nie moe by uywane w nie zarzdzanym rodowisku");
    }

    public Object createConnectionFactory(ConnectionManager cm)
        throws ResourceException
    {
        log.debug("metoda createConnectionFactory, cm=" + cm, new Exception("Woana przez:"));
        FSRequestInfo fsInfo = new FSRequestInfo(rootDir);
        return new DirContextFactoryImpl(cm, this, fsInfo);
    }

    public ManagedConnection createManagedConnection(Subject subject,
                                                     ConnectionRequestInfo info)
        throws ResourceException
    {
        log.debug("metoda createManagedConnection, subject=" + subject + ", info=" + info,
                  new Exception("Woana przez:"));
        FSRequestInfo fsInfo = (FSRequestInfo) info;
        return new FSManagedConnection(subject, fsInfo);
    }

    public ManagedConnection matchManagedConnections(Set connectionSet, 
                                                     Subject subject,
                                                     ConnectionRequestInfo info)
        throws ResourceException
    {
        log.debug("metoda matchManagedConnections, connectionSet=" + 
                  connectionSet + ", subject=" + subject  +", info="  +info);
        return (ManagedConnection) connectionSet.iterator().next();
    }
    
    public PrintWriter getLogWriter() 
        throws ResourceException
    {
        return null;
    }
    

    public void setLogWriter(PrintWriter out) 
        throws ResourceException
    {
    }

    public boolean equals(Object other)
    {
        return super.equals(other);
    }

    public int hashCode()
    {
        return super.hashCode();
    }
    
    public void setFileSystemRootDir(String rootDirPath)
    {
        this.rootDirPath = rootDirPath;
        rootDir = new File(rootDirPath);

        if (rootDir.exists() == false) {
            rootDir.mkdirs();
        }
        log.debug("metoda setFileSystemRootDir, rootDir=" + rootDir.getAbsolutePath(),
                  new Exception("Woana przez:"));
   }
}
