package org.jboss.chap8.ex3;

import java.rmi.RemoteException;
import javax.naming.InitialContext;
import javax.security.auth.login.LoginContext;

import org.jboss.security.auth.callback.UsernamePasswordHandler;
import org.jboss.util.ChapterExRepository;

/**
 *
 * @author  Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class ExClient
{
   public static void main(String args[]) throws Exception
   {
      // Konfiguracja przykadowego repozytorium log4j
      ChapterExRepository.init(ExClient.class);

      // Logowanie przy uyciu protokou SRP
      System.out.println("Rejestracja przy uyciu konfiguracji 'srp'");
      String username = args[0];
      char[] password = args[1].toCharArray();
      UsernamePasswordHandler handler = new UsernamePasswordHandler(username, password);
      LoginContext lc = new LoginContext("srp", handler);
      lc.login();
      InitialContext iniCtx = new InitialContext();
      Object ref = iniCtx.lookup("EchoBean3");
      EchoHome home = (EchoHome) ref;
      Echo echo = home.create();
      System.out.println("Utworzono Echo");
      System.out.println("Echo.echo()#1 = "+echo.echo("To jest wywoanie nr. 1"));
      Thread.currentThread().sleep(15*1000);
      /* To si nie uda, ze wzgldu na limit czasu pamici podrcznej SRP, jeli
         limit czasu pamici podrcznej JaasSecurityManager bdzie mie
         takie same wartoci.
       */
      try
      {
         System.out.println("Echo.echo()#2 = "+echo.echo("To jest wywoanie nr. 2"));
      }
      catch(Throwable e)
      {
         while( e instanceof RemoteException )
         {
            RemoteException re = (RemoteException) e;
            e = re.detail;
         }
         System.out.println("Niepowodzenie Echo.echo()#2. Zgoszono wyjtek: "+e.getMessage());
      }
      lc.logout();
   }
}
