/*
* JBoss, the OpenSource J2EE webOS
*
* Distributable under LGPL license.
* See terms of license at gnu.org.
*/
package org.jboss.chap8.ex3a.service;

import java.util.Vector;
import org.jboss.system.Service;

/** Pomocniczy mbean monitorujcy czonkostwo partycji klastra oraz
 * tworzcy obiekt DistributedTimedCachePolicy
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public interface DistributedCacheServiceMBean extends Service
{
   /** Pobranie nazwy partycji klasta monitorowanego przez ten mbean
    */
   public String getPartitionName();
   /** Okrelenie nazwy partycji klastra monitorowanego przez ten mbean
    */
   public void setPartitionName(String name);

   /** Pobranie nazwy pod ktr obiekt CachePolicy jest dostpny JNDI
    */
   public String getCacheJndiName();
   /** Okrelenie nazwy pod ktr obiekt CachePolicy jest dostpny JNDI
    */
   public void setCacheJndiName(String name);

   /** Pobranie limitu czasu pamici podrcznej (wyraonego w sekundach)
    */
   public int getCacheTimeout();
   /** Okrelenie limitu czasu pamici podrcznej (wyraonego w sekundach)
    */
   public void setCacheTimeout(int timeoutSecs);

   /** Pobranie informacji o czonkostwie biecej partycji klastra
    *@return obiekt Vector zawierajcy implementacje org.javagroups.Address , na przykad,
    *org.javagroups.stack.IpAddress
    */
   public Vector getClusterNodes();

   /** Pobranie wartoci polityki pamici podrcznej
    */
   public Object get(String key);
   /** Okrelnie wartoci polityki pamici podrcznej
    */
   public void set(String key, String value);
}
