package org.jboss.chap8.ex3b;

import java.rmi.RemoteException;
import javax.naming.InitialContext;
import javax.security.auth.login.LoginContext;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.FileAppender;
import org.apache.log4j.PatternLayout;

import org.jboss.logging.XLevel;
import org.jboss.security.auth.callback.UsernamePasswordHandler;
import org.jboss.chap8.ex3a.EchoHome;
import org.jboss.chap8.ex3a.Echo;

/** Test dostpu do komponentw EJBs uywajcy HTTP obsugiwanego przez klaster 
 * jako protokou transportowego uywanego przez SRP stanowicego mechanizm
 * uwierzytelniania. SRP, podobnie jak JNDI, uywa protokou HTTP obsugiwanego
 * w taki sposb. JNDI jest take zabezpieczane pojedynczym kontekstem tylko do odczutu.
 * @author  Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class ExClient
{
   public static void main(String args[]) throws Exception
   {
      // Przygotowanie pojedynczej konfiguracji wywietlajcej rejestrowane informacje
      // na konsoli
      FileAppender fa = new FileAppender(new PatternLayout("%r[%c{1}], %m%n"), "ex3b-trace.log");
      fa.setAppend(false);
      Logger cat = Logger.getLogger("org.jboss.security");
      cat.setLevel(XLevel.TRACE);
      cat.setAdditivity(false);
      cat.addAppender(fa);

      cat = Logger.getLogger("org.jboss.invocation");
      cat.setLevel(XLevel.TRACE);
      cat.setAdditivity(false);
      cat.addAppender(fa);

      // Logowanie przy uyciu SRP
      System.out.println("Logowanie przy uyciu konfiguracji 'srpHAReadOnlyJNDI'");
      String username = args[0];
      char[] password = args[1].toCharArray();
      UsernamePasswordHandler handler = new UsernamePasswordHandler(username, password);
      LoginContext lc = new LoginContext("srpHAReadOnlyJNDI", handler);
      lc.login();
      InitialContext iniCtx = new InitialContext();
      Object ref = iniCtx.lookup("EchoBean3a");
      EchoHome home = (EchoHome) ref;
      Echo echo = home.create();
      System.out.println("Utworzono Echo");
      // Wykonanie kilku wywoa kierowanych do klastra
      for(int c = 1; c <= 4; c ++)
      {
         System.out.println("Echo.echo()#"+c+" = "+echo.echo("To wywoanie nr.:"+c));
      }
      lc.logout();
   }
}
