package org.jboss.chap8.service;

import org.jboss.system.ServiceMBean;

/** Interfejs dla usugi konfiguracyjnej, ktra umieszcza 
 opisywane w xml-u obiety javax.security.auth.login.Configuration na stosie
 zarzdzanym przez komponent mbean o nazwie okrelonej przez atrybut
 SecurityConfigName.
 
 @see org.jboss.security.plugins.SecurityConfigMBean

 @author Scott.Stark@jboss.org
 @version $Revision: 1.1 $
 */
public interface SecurityConfigMBean extends ServiceMBean
{
   /** Pobiera nazw zasobu zawierajcego plik konfiguracji bezpieczestwa */
   public String getAuthConfig();
   /** Ustawia nazw zasobu zawierajcego plik konfiguracji bezpieczestwa */
   public void setAuthConfig(String configURL);
   /** Pobiera nazw komponentu mbean SecurityConfig ktrego metody 
       pushLoginConfig oraz popLoginConfig bd uywane do instalowania 
       i usuwania konfiguracji logowania zapisanej w kodzie XML */
   public String getSecurityConfigName();
   /** Okrela nazw komponentu mbean SecurityConfig ktrego metody 
       pushLoginConfig oraz popLoginConfig bd uywane do instalowania 
       i usuwania konfiguracji logowania zapisanej w kodzie XML */
   public void setSecurityConfigName(String objectName);
}
