package org.jboss.cmp2.crimeportal;

import java.util.Iterator;
import javax.naming.InitialContext;
import javax.ejb.EJBLocalObject;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.test.util.ejb.EJBTestCase;

public class CrimePortalTearDown extends EJBTestCase
{
   public static Test suite()
   {
      TestSuite testSuite = new TestSuite("CrimePortalTearDown");
      testSuite.addTestSuite(CrimePortalTearDown.class);
      return testSuite;
   }

   public CrimePortalTearDown(String name)
   {
      super(name);
   }

   public void testTearDown() throws Exception
   {
      InitialContext jndi = new InitialContext();

      // usunicie wszystkich organizacji
      OrganizationHome organizationHome =
         (OrganizationHome) jndi.lookup("crimeportal/Organization");
      Iterator organizations = organizationHome.findAll().iterator();
      while (organizations.hasNext())
      {
         EJBLocalObject ejb = (EJBLocalObject) organizations.next();
         ejb.remove();
      }

      // usunicie wszystkich gangsterw (mona by zastosowa mechanizm
      // usuwania kaskadowego, ale tak bdzie bezpieczniej)
      GangsterHome gangsterHome =
         (GangsterHome) jndi.lookup("crimeportal/Gangster");
      Iterator gangsters = gangsterHome.findAll().iterator();
      while (gangsters.hasNext())
      {
         EJBLocalObject ejb = (EJBLocalObject) gangsters.next();
         ejb.remove();
      }

      // usunicie wszystkich zada
      JobHome jobHome = (JobHome) jndi.lookup("crimeportal/Job");
      Iterator jobs = jobHome.findAll().iterator();
      while (jobs.hasNext())
      {
         EJBLocalObject ejb = (EJBLocalObject) jobs.next();
         ejb.remove();
      }

      // usunicie wszystkich lokalizacji (mona by zastosowa mechanizm
      // usuwania kaskadowego, ale tak bdzie bezpieczniej).
      LocationHome locationHome =
         (LocationHome) jndi.lookup("crimeportal/Location");
      Iterator locations = locationHome.findAll().iterator();
      while (locations.hasNext())
      {
         EJBLocalObject ejb = (EJBLocalObject) locations.next();
         ejb.remove();
      }
   }
}
