package org.jboss.cmp2.crimeportal;

import javax.ejb.EJBLocalObject;

public interface Location extends EJBLocalObject
{
   public abstract Integer getLocationID();

   /**
    * Odczyt opis adresu.
    * @return opis adresu
    */
   public abstract String getDescription();

   /**
    * Podanie opisu adresu.
    * @param description nowy opis adresu
    */
   public abstract void setDescription(String description);

   /**
    * Odczyt nazwy ulicy.
    * @return nazwa ulicy
    */
   public abstract String getStreet();

   /**
    * Podanie nazwy ulicy.
    * @param street nowa nazwa ulicy
    */
   public abstract void setStreet(String street);
 
   /**
    * Odczyt nazwy miasta.
    * @return nazwa miasta
    */
   String getCity();

   /**
    * Podanie nowej nazwy miasta
    * @param city nowa nazwa miasta
    */
   void setCity(String city);

   /**
    * Odczyt dwuliterowego kodu stanu.
    * @return dwuliterowy kod stanu
    */
   String getState();

   /**
    * Podanie dwuliterowego kodu stanu.
    * @param state nowe dwuliterowe okrelenie stanu
    * @throws IllegalArgumentException jeli okrelenie stanu nie zawiera 
    * dokadnie dwch liter
    */
   void setState(String state);
   
   /**
    * Odczyt kodu pocztowego.
    * @return kod pocztowy
    */
   int getZipCode();

   /**
    * Okrelenie nowego kodu podcztowego.
    * @param zipCode nowy kod pocztowy
    * @throws IllegalArgumentException jeli kod jest liczb ujemn lub jeli 
    * ma wicej ni 5 cyfr.
    */
   void setZipCode(int zipCode);
}
