package org.jboss.cmp2.crimeportal;

import org.apache.log4j.Category;
import java.util.Collection;
import java.util.Set;
import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;

public abstract class OrganizationBean implements EntityBean
{
   private Category log = Category.getInstance(getClass());
   private EntityContext ctx;

   public String ejbCreate(String name, String description) 
      throws CreateException
   {
      log.info("Tworzenie organizacji " + name + ", " + description);
      setName(name);
      setDescription(description);
      return null;
   }

   public void ejbPostCreate(String name, String description)
   {
   }

   // Metody dostpu do pl CMP -----------------------------------------------------
   public abstract String getName();
   public abstract void setName(String param);

   public abstract String getDescription();
   public abstract void setDescription(String param);

   // Metody dostpu do pl CMR -----------------------------------------------------
   public abstract Set getMemberGangsters();
   public abstract void setMemberGangsters(Set gangsters);

   public abstract Gangster getTheBoss();
   public abstract void setTheBoss(Gangster theBoss);

   // Metody ejbSelect -------------------------------------------------------
   public abstract Collection ejbSelectOperatingZipCodes_declaredsql(
         String name) throws FinderException;

   // Metody ejbHome ---------------------------------------------------------
   public Collection ejbHomeSelectOperatingZipCodes_declaredsql(String name)
         throws FinderException {

      return ejbSelectOperatingZipCodes_declaredsql(name.trim().toLowerCase());
   }

   // Metody zwrotne EJB -----------------------------------------------------------
   public void setEntityContext(EntityContext context)
   {
      ctx = context;
   }

   public void unsetEntityContext()
   {
      ctx = null;
   }

   public void ejbActivate()
   {
   }

   public void ejbPassivate()
   {
   }

   public void ejbRemove()
   {
      log.info("Usuwanie " + getName());
   }

   public void ejbStore()
   {
   }

   public void ejbLoad()
   {
   }
}
