package org.jboss.jbossaop.MortgageCalculator.servlet;

import javax.servlet.*;
import javax.servlet.http.*;
import org.jboss.jbossaop.MortgageCalculator.business.*;
import java.io.*;

public class CalculatorServlet extends HttpServlet {

  private Calculator cal = null;

  public void init () throws ServletException {
    cal = new Calculator ();
  }

  public void service(HttpServletRequest request,
                      HttpServletResponse response)
      throws IOException, ServletException {

    response.setContentType("text/html; encoding=ISO-8859-2");

    ServletOutputStream out = response.getOutputStream();

    String para = null;
    int principal = 200000;
    double rate = 8.0;
    int term = 360;
    double payment = 0.;

    para = request.getParameter("principal");
    if (para != null && para.length() > 0) {
      principal = Integer.parseInt(para);
    }

    para = request.getParameter("rate");
    if (para != null && para.length() > 0) {
      rate = Double.parseDouble(para);
    }

    para = request.getParameter("term");
    if (para != null && para.length() > 0) {
      term = Integer.parseInt(para);
    }

    try {
      payment = cal.getPayment(principal, rate, term);

      out.println("<html>");
      out.println("<head><title>Kalkulator hipoteczny</title></head>");

      out.println("<body>");
      out.println("<h1>Kalkulator hipoteczny</h1>");

      out.println("<form action=\"Calculator\" method=\"get\">");
      out.println("Suma poyczki (USD):");
      out.println("<input type=\"text\" name=\"principal\" value=\"");
      out.print(principal);
      out.println("\">");
      out.println("<br/>");

      out.println("Oprocentowanie (w skali roku):");
      out.println("<input type=\"text\" name=\"rate\" value=\"");
      out.print(rate);
      out.println("\">");
      out.println("<br/>");

      out.println("Okres poyczki (w miesicach):");
      out.println("<input type=\"text\" name=\"term\" value=\"");
      out.print(term);
      out.println("\">");
      out.println("<br/>");

      out.println("<input type=\"submit\" value=\"Wylicz\">");
      out.println("</form>");

      out.println("<p>Miesiczna rata wynosi:");
      out.println("<b>");
      out.print(payment);
      out.println("</b>");
      out.println("USD</p>");

      out.println("</body>");
      out.println("</html>");
    } catch (Throwable e) {
      out.println("<html>");
      out.println("<head><title>Bd</title></head>");

      out.println("<body>");
      out.println("<h1>Bd</h1>");
      out.println("<p>Moe zosta przekroczony limit ");
      out.println("lub nie dysponujesz odpowiednimi uprawnieniami");
      out.println("<br>");
      out.println("<p>Komunikat bdu:");
      out.println("<pre>");
      out.println(e.getMessage());
      out.println("</pre>");
      out.println("</body>");
      out.println("</html>");
    }
  }
}
